#include "ItemEntity.h"
#include "Game.h"
#include "EntityChangedUpdate.h"


ItemEntity::ItemEntity( Framework::Vec3<float> location, int dimensionId, int entityId )
    : Entity( ItemEntityType::INSTANCE, location, dimensionId, entityId )
{
    ItemSlot* slot = new ItemSlot( __INT32_MAX__, 0, 0, 0, ANY_DIRECTION, 0 );
    addSlot( slot );
    faceOffset = { 0.f, 0.f, 0.f };
    maxHP = 10;
    currentHP = 10;
    stamina = 10;
    maxStamina = 10;
    hunger = 10;
    maxHunger = 10;
    thirst = 10;
    maxThirst = 10;
    targetDistanceLimit = 4;
}

void ItemEntity::tick( const Dimension* zDimension )
{
    Framework::Vec3<float> pos = location;
    // TODO: add speed to next entity with free inventory
    Entity::tick( zDimension );
    if( pos != location )
    {
        Game::INSTANCE->requestWorldUpdate( new EntityChangedUpdate( id, (Framework::Vec3<int>)location, currentDimensionId ) );
    }
}

void ItemEntity::api( Framework::StreamReader* zRequest, NetworkResponse* zResponse )
{

}

void ItemEntity::onFall( float collisionSpeed )
{
    if( collisionSpeed >= 50.f )
        this->currentHP = 0;
}


ItemEntityType::ItemEntityType()
    : EntityType( ID )
{}

Entity* ItemEntityType::createEntity( Framework::Vec3<float> position, int dimensionId, int entityId ) const
{
    return new ItemEntity( position, dimensionId, entityId );
}
